class AR_Audio
 {
  private:

   ALLEGRO_VOICE *voice;
   ALLEGRO_MIXER *mixer;
   ALLEGRO_SAMPLE_INSTANCE **sound_instances;
   ALLEGRO_SAMPLE_INSTANCE **music_instances;
   int total_sound_instances,total_music_instances;

  public:

   AR_Audio(AR_Display *display, int total_sound_instances = 14, int total_music_instances = 1)
    {
	 // Init audio, create voice and mixer
     if(!al_install_audio()) { AR_Util::errorBox(display->getDisplay(),"Failed to initialize audio!"); exit(1); }
     voice = al_create_voice(44100,ALLEGRO_AUDIO_DEPTH_INT16,ALLEGRO_CHANNEL_CONF_2);
     if(!voice)              { AR_Util::errorBox(display->getDisplay(),"Failed to initialize voice!"); exit(1); }
     mixer = al_create_mixer(44100,ALLEGRO_AUDIO_DEPTH_FLOAT32,ALLEGRO_CHANNEL_CONF_2);
     if(!mixer)              { AR_Util::errorBox(display->getDisplay(),"Failed to initialize mixer!"); exit(1); }
     if(!al_attach_mixer_to_voice(mixer,voice)) { AR_Util::errorBox(display->getDisplay(),"Failed to attach mixer to voice!"); exit(1); }

     // Init sample instance
     this->total_sound_instances = total_sound_instances;
     this->total_music_instances = total_music_instances;
     sound_instances = (ALLEGRO_SAMPLE_INSTANCE **)malloc(sizeof(ALLEGRO_SAMPLE_INSTANCE *)*total_sound_instances);
     music_instances = (ALLEGRO_SAMPLE_INSTANCE **)malloc(sizeof(ALLEGRO_SAMPLE_INSTANCE *)*total_sound_instances);
     for(int i=0;i<total_sound_instances;i++)
      {
       sound_instances[i] = al_create_sample_instance(NULL);
       if(!sound_instances[i])
        { AR_Util::errorBox(display->getDisplay(),"Failed to create sample instance for sounds!"); exit(1); }
       if(!al_attach_sample_instance_to_mixer(sound_instances[i],mixer))
        { AR_Util::errorBox(display->getDisplay(),"Failed to attach sounds sample instance to mixer!"); exit(1); }
      }
     for(int i=0;i<total_music_instances;i++)
      {
       music_instances[i] = al_create_sample_instance(NULL);
       if(!sound_instances[i])
        { AR_Util::errorBox(display->getDisplay(),"Failed to create sample instance for musics!"); exit(1); }
       if(!al_attach_sample_instance_to_mixer(music_instances[i],mixer))
        { AR_Util::errorBox(display->getDisplay(),"Failed to attach musics sample instance to mixer!"); exit(1); }
      }
	}

   ~AR_Audio() { }

   ALLEGRO_SAMPLE_INSTANCE *getSoundInstance(int n) { return sound_instances[n]; }
   
   ALLEGRO_SAMPLE_INSTANCE *getMusicInstance(int n) { return music_instances[n]; }

   int getTotalSoundInstances() { return total_sound_instances; }

 };
