class AR_Sample
 {
  private:

   AR_Audio *audio;
   ALLEGRO_SAMPLE *sample;
   ALLEGRO_SAMPLE_INSTANCE *current_sample_instance;

  public:

   AR_Sample(string filename, AR_Audio *audio, AR_Sample *p = NULL)
    {
     this->audio = audio;
     if(p == NULL) sample = al_load_sample(filename.c_str());
     else          sample = p->getSample();
     if(!sample) { AR_Util::errorBox(NULL,string("File '") + string(filename) + string("' not found or bad audio format!")); /*AR_Util::errorBox(display->getDisplay(),string("File '") + string(filename) + string("' not found or bad audio format!"));*/ exit(1); }
     current_sample_instance = NULL;
	}

   ~AR_Sample() { }

   void play()
    {
	 for(int i=0;i<audio->getTotalSoundInstances();i++)
	  {
	   printf("\nplay ");
	   if(!al_get_sample_instance_playing(audio->getSoundInstance(i)))
	    {
		 current_sample_instance = audio->getSoundInstance(i);
         al_set_sample(audio->getSoundInstance(i),sample);
         al_set_sample_instance_playmode(audio->getSoundInstance(i),ALLEGRO_PLAYMODE_ONCE);
         al_play_sample_instance(audio->getSoundInstance(i));
         printf("-> %d [%p] = [%p]\n",i,al_get_sample_data(al_get_sample(current_sample_instance)),al_get_sample_data(sample));
         break;
	    }
      }
	}

   bool isPlaying()
    {
	 if(current_sample_instance != NULL)
	  if(al_get_sample_instance_playing(current_sample_instance))
	   if(al_get_sample_data(al_get_sample(current_sample_instance)) == al_get_sample_data(sample))
	    return true;
	 return false;
	}

   AR_Audio *getAudio()        { return audio;  }

   ALLEGRO_SAMPLE *getSample() { return sample; }

 };
