class Missile : public Bullet
 {
  private:
   float *target_x,*target_y; // Pointers to missile target
   float speed;

  public:

   Missile(string filename, AR_Display *display, Missile *p = NULL) : Bullet(filename,display,p)
    {
	 target_x = target_y = NULL;
	 reset();
	}

   ~Missile() { }

   void debug()
    {
	 if(action == AR::NONE) return;

     if(target_x != NULL && target_y!= NULL)
      al_draw_filled_circle((*target_x)-(*scroll_x),(*target_y)-(*scroll_y),28,al_map_rgb(255,255,255));
	}

   void run()
    {
	 AR_Sprite::run();
	   //life--;
	   //if(life == 0) action = AR::FADE;
	 if(action == AR::LAUNCHED)
	  {
	   if(speed_y < 0.3) acceleration_y = 0.1;
	   if(speed_y > 2.1) action = AR::FOLLOW;
      }
     if(action == AR::FOLLOW)
      {
       // Aim to direction
       float dx,dy,angle,cosa,sina;
       float move_x,move_y;

       move_x = *(this->target_x);
       move_y = *(this->target_y);
       dx = move_x-x;
	   dy = move_y-y;
	   angle = atan2(dy,dx);
       cosa = cos(angle);
       sina = -sin(angle);

       if(cosa > 0)
        if(speed_x > speed*cosa) acceleration_x = -0.08*cosa;
        else                     acceleration_x =  0.08*cosa;
       else
        if(speed_x > speed*cosa) acceleration_x =  0.08*cosa;
       else                      acceleration_x = -0.08*cosa;

       if(sina > 0)
        if(speed_y > speed*sina) acceleration_y = -0.1*sina;
        else                     acceleration_y =  0.1*sina;
       else
        if(speed_y > speed*sina) acceleration_y =  0.1*sina;
        else                     acceleration_y = -0.1*sina;
	  }
	 /*
	 if(action == AR::FADE)
	  {
	   setAlpha(getAlpha() - 10);
	   if(getAlpha() == 0) action = AR::NONE;
      }*/
	}

   void draw()
    {
	 if(action != AR::NONE)
	  {
	   AR_Sprite::draw();
	   // TODO fare exhaust ...
      }
    }

   void shoot(float x, float y, float angle, float power, int life, float friction_x, float friction_y, float acceleration_x, float acceleration_y, float gravity_x, float gravity_y,float *target_x, float *target_y)
    {
	 if(action == AR::NONE)
	  {
	   //power = power + (float)AR_Util::random(10) * 0.1; //random factor TODO ???
       setX(x); setY(y);
       setSpeedX(power*(cos(AR_Util::radians(angle+AR_Util::random(2)-1))));
       setSpeedY(power*(-sin(AR_Util::radians(angle+AR_Util::random(2)-1))));
       setFrictionX(friction_x);
       setFrictionY(friction_y);
       setGravityX(gravity_x);
       setGravityY(gravity_y);
       setAccelerationX(acceleration_x);
       setAccelerationY(acceleration_y);
	   setAngle(angle);
	   setAlpha(200);
	   setLife(life);
	   this->target_x = target_x;
	   this->target_y = target_y;
	   action = AR::LAUNCHED;
      }
	}

   void reset()
    {
	 // Reset variables to default
	 Bullet::reset();
	 speed = 4;
	}

 };
